netstart revision 1.58
1#!/bin/sh -
2#
3#	$OpenBSD: netstart,v 1.58 2000/01/02 06:32:44 itojun Exp $
4
5# Returns true if $1 contains only alphanumerics
6isalphanumeric() {
7	local _n
8	_n=$1
9	while [ ${#_n} != 0 ]; do
10		case $_n in
11			[A-Za-z0-9]*)	;;
12			*)		return 1;;
13		esac
14		_n=${_n#?}
15	done
16	return 0
17}
18
19# /etc/myname contains my symbolic name
20#
21hostname=`cat /etc/myname`
22hostname $hostname
23if [ -f /etc/defaultdomain ]; then
24	domainname `cat /etc/defaultdomain`
25fi
26
27# pick up option configuration
28. /etc/rc.conf
29
30# Configure the IP filter before configuring network interfaces
31if [ X"${ipfilter}" = X"YES" -a -f "${ipfilter_rules}" ]; then
32	echo 'configuring IP filter'
33	ipf -Fa -f ${ipfilter_rules} -E
34else
35	ipfilter=NO
36fi
37
38# set the address for the loopback interface
39# it will also initialize IPv6 address for lo0 (::1 and others).
40ifconfig lo0 inet localhost
41
42# use loopback, not the wire
43route -n add -host $hostname localhost
44route -n add -net 127 127.0.0.1 -reject
45
46if ifconfig lo0 inet6 >/dev/null 2>&1; then
47	# IPv6 configurations.
48	ip6kernel=YES
49
50	# disallow scoped unicast dest without outgoing scope identifiers.
51	route add -inet6 fe80:: -prefixlen 10 ::1 -reject
52	route add -inet6 fc80:: -prefixlen 10 ::1 -reject
53	# disallow "internal" addresses to appear on the wire.
54	route add -inet6 ::ffff:0.0.0.0 -prefixlen 96 ::1 -reject
55	route add -inet6 ::0.0.0.0 -prefixlen 96 ::1 -reject
56
57	rtsolif=""
58else
59	ip6kernel=NO
60fi
61
62# configure all of the non-loopback interfaces which we know about.
63# refer to hostname.if(5) and bridgename.if(5)
64for hn in /etc/hostname.*; do
65    # Strip off /etc/hostname. prefix
66    if=${hn#/etc/hostname.}
67
68    # Interface names must be alphanumeric only.  We check to avoid
69    # configuring backup or temp files, and to catch the "*" case.
70    if ! isalphanumeric "$if"; then
71	continue
72    fi
73    ifconfig $if > /dev/null 2>&1
74    if [ "$?" != "0" ]; then
75	continue
76    fi
77
78    # Now parse the hostname.* file
79    while :; do
80	if [ "$cmd2" ]; then
81	    # we are carrying over from the 'read dt dtaddr' last time
82	    set -- $cmd2
83	    af="$1" name="$2" mask="$3" bcaddr="$4" ext1="$5" ext2="$6"
84	    cmd2=
85	else
86	    # read the next line or exit the while loop
87	    read af name mask bcaddr ext1 ext2 || break
88	fi
89	# skip comments
90	[ "${af#*#}" = "${af}" ] || continue
91	# $af can be either "dhcp", "up" or an address family.
92	case "$af" in
93	"bridge")
94	    cmd="echo ${hn}: bridges now supported via bridgename.* files"
95	    ;;
96	"dhcp")
97	    ifconfig $if $name $mask $bcaddr $ext1 $ext2 down
98	    cmd="dhclient $if"
99	    ;;
100	"rtsol")
101	    ifconfig $if $name $mask $bcaddr $ext1 $ext2 down
102	    rtsolif="$rtsolif $if"
103	    ;;
104	"up")
105	    # The only one of these guaranteed to be set is $if
106	    # the remaining ones exist so that media controls work
107	    cmd="ifconfig $if $name $mask $bcaddr $ext1 $ext2 up"
108	    ;;
109	*)
110	    read dt dtaddr
111	    if [ "$name"  = "alias" ]; then
112		# perform a 'shift' of sorts
113		alias=$name
114		name=$mask
115		mask=$bcaddr
116		bcaddr=$ext1
117		ext1=$ext2
118		ext2=
119	    fi
120	    cmd="ifconfig $if $af $alias $name "
121	    case $dt in
122	    dest)
123		cmd="$cmd $dtaddr"
124		;;
125	    [a-z]*)
126		cmd2="$dt $dtaddr"
127		;;
128	     esac
129	     if [ ! -n "$name" ]; then
130		    echo "/etc/hostname.$if: invalid network configuration file"
131		return
132	     fi
133	     case $af in
134	     inet)
135		[ "$mask" ] && cmd="$cmd netmask $mask"
136		if [ "$bcaddr" -a "X$bcaddr" != "XNONE" ]; then
137		    cmd="$cmd broadcast $bcaddr"
138		fi
139		[ "$alias" ] && rtcmd="; route -n add -host $name 127.0.0.1"
140	     ;;
141	     inet6) [ "$mask" ] && cmd="$cmd prefixlen $mask"
142		cmd="$cmd $bcaddr"
143		;;
144	     *) cmd="$cmd $mask $bcaddr"
145	     esac
146	     cmd="$cmd $ext1 $ext2$rtcmd" rtcmd=
147	     ;;
148	esac
149	eval "$cmd"
150    done < /etc/hostname.$if
151done
152
153if [ "$ip6kernel" = "YES" -a "x$rtsolif" != "x" ]; then
154	fw=`sysctl -n net.inet6.ip6.forwarding`
155	ra=`sysctl -n net.inet6.ip6.accept_rtadv`
156	if [ "x$fw" = "x0" -a "x$ra" = "x1" ]; then
157		echo "IPv6 autoconf:$rtsolif"
158		rtsol $rtsolif
159	else
160		echo "WARNING: inconsistent config - check /etc/sysctl.conf for IPv6 autoconf"
161	fi
162fi
163if [ "$ip6kernel" = "YES" ]; then
164	# this is to make sure DAD is completed before going further.
165	sleep `sysctl -n net.inet6.ip6.dad_count`
166	sleep 1
167fi
168
169for bn in /etc/bridgename.*; do
170    # Strip off /etc/bridgename. prefix
171    if=${bn#/etc/bridgename.}
172
173    # Interface names must be alphanumeric only.  We check to avoid
174    # configuring backup or temp files, and to catch the "*" case.
175    if ! isalphanumeric "$if"; then
176        continue
177    fi
178    brconfig $if > /dev/null 2>&1
179    if [ "$?" != "0" ]; then
180	continue
181    fi
182
183    # Now parse the bridgename.* file
184    {
185	# All lines are run as brconfig(8) commands.
186	while read line ; do
187	    line=${line%%#*}		# strip comments
188	    test -z "$line" && continue
189	    brconfig $if $line
190	done
191    } < /etc/bridgename.$if
192done
193
194# /etc/mygate, if it exists, contains the name of my gateway host
195# that name must be in /etc/hosts.
196if [ -f /etc/mygate ]; then
197	route -n add -host default `cat /etc/mygate`
198fi
199
200# Multicast routing.
201#
202# The routing to the 224.0.0.0/4 net is setup according to these rules:
203# multicast_host	multicast_router	route		comment
204# NO			NO			-reject		no multicast
205# NO			YES			none installed	daemon will run
206# YES/interface		NO			-interface	YES=def. iface
207#	   Any other combination		-reject		config error
208case "$multicast_host:$multicast_router" in
209NO:NO)
210	route -n add -net 224.0.0.0/4 -interface 127.0.0.1 -reject;;
211NO:YES)
212	;;
213*:NO)
214	set `if [ $multicast_host = YES ]; then
215		ed -s '!route -n show' <<EOF
216/^default/p
217EOF
218	else
219		ed -s "!ifconfig $multicast_host" <<EOF
220/^	inet /p
221EOF
222	fi`
223	route -n add -net 224.0.0.0/4 -interface $2;;
224*:*)
225	echo 'config error, multicasting disabled until rc.conf is fixed'
226	route -n add -net 224.0.0.0/4 -interface 127.0.0.1 -reject;;
227esac
228
229# Configure NAT after configuring network interfaces
230if [ "${ipnat}" = "YES" -a "${ipfilter}" = "YES" -a -f "${ipnat_rules}" ]; then
231	echo 'configuring NAT'
232	ipnat -CF -f ${ipnat_rules}
233else
234	ipnat=NO
235fi
236